package com.chelvc.framework.base.context;

import org.springframework.context.ApplicationListener;
import org.springframework.stereotype.Component;

/**
 * 场景分组事件监听器
 *
 * @author Woody
 * @date 2024/12/3
 */
@Component
public class GroupEventListener implements ApplicationListener<GroupEvent> {
    @Override
    public void onApplicationEvent(GroupEvent event) {
        Session session = SessionContextHolder.getSession(false);
        if (session != null) {
            session.setGroup(event.getScene(), event.getGroup());
        }
    }
}
