package com.chelvc.framework.database.sql;

import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.SQLType;

import com.chelvc.framework.database.context.DatabaseContextHolder;

/**
 * 字符串写入加密处理器
 *
 * @author Woody
 * @date 2024/6/8
 */
public class WriteStringEncryptor extends PreparedStatementWrapper {
    public WriteStringEncryptor(PreparedStatement delegate) {
        super(delegate);
    }

    @Override
    public void setObject(int parameterIndex, Object x) throws SQLException {
        if (x instanceof String) {
            this.setString(parameterIndex, (String) x);
        }
    }

    @Override
    public void setObject(int parameterIndex, Object x, int targetSqlType) throws SQLException {
        if (x instanceof String) {
            this.setString(parameterIndex, (String) x);
        }
    }

    @Override
    public void setObject(int parameterIndex, Object x, int targetSqlType, int scaleOrLength) throws SQLException {
        if (x instanceof String) {
            this.setString(parameterIndex, (String) x);
        }
    }

    @Override
    public void setObject(int parameterIndex, Object x, SQLType targetSqlType) throws SQLException {
        if (x instanceof String) {
            this.setString(parameterIndex, (String) x);
        }
    }

    @Override
    public void setObject(int parameterIndex, Object x, SQLType targetSqlType, int scaleOrLength) throws SQLException {
        if (x instanceof String) {
            this.setString(parameterIndex, (String) x);
        }
    }

    @Override
    public void setString(int parameterIndex, String x) throws SQLException {
        if (DatabaseContextHolder.isSensitiveWritable() && x != null) {
            x = DatabaseContextHolder.getCryptoContext().encrypt(x, true);
        }
        super.setString(parameterIndex, x);
    }
}
