package com.chelvc.framework.group;

import com.chelvc.framework.base.context.SessionContextHolder;
import lombok.NonNull;

/**
 * 基于用户ID分组选择器实现
 *
 * @author Woody
 * @date 2024/9/8
 */
public class IdentityGroupSelector implements GroupSelector {
    @Override
    public int grouping(int count, @NonNull Object... args) {
        Long id = SessionContextHolder.getId();
        return id == null ? -1 : (int) (id % count);
    }
}
